package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.types.ColumnType

public interface CreateInsertQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> :_CreateInsertOrCopyQueryScope<TargetTableUserExtension, QueryUserExtension> {
	public class DataParam<@Suppress("unused") QueryUserExtension : Any> private constructor()

	public val dataExpressionBuilder: Expression.Builder<DataParam<QueryUserExtension>>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> dataParam(name: String, type: DatabaseType): InputParam<RuntimeType, DatabaseType, DataParam<QueryUserExtension>>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> insertParam(
		column: Column<RuntimeType, DatabaseType, TargetTableUserExtension>,
		paramName: String = column.name,
	): InputParam<RuntimeType, DatabaseType, DataParam<QueryUserExtension>>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> insert(column: Column<RuntimeType, DatabaseType, TargetTableUserExtension>, expression: Expression<RuntimeType, DatabaseType, DataParam<QueryUserExtension>>)
}