package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.types.ColumnType

public interface CreateUpdateQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonCreateQueryScope<QueryUserExtension> {
	public val targetTable: SelectedTable<TargetTableUserExtension, QueryUserExtension>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> selectOldColumnValue(c: Column<RuntimeType, DatabaseType, TargetTableUserExtension>): Expression<RuntimeType, DatabaseType, QueryUserExtension>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> updateColumn(c: Column<RuntimeType, DatabaseType, TargetTableUserExtension>, e: Expression<RuntimeType, DatabaseType, QueryUserExtension>)

	public fun where(expression: Expression<Boolean, ColumnType.BOOLEAN, QueryUserExtension>)

	public fun limit(size: UInt)

	@Suppress("SpellCheckingInspection")
	public fun offsetedLimit(offset: ULong, size: UInt)

	public val returning: _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension>
}