package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.LowLevelApi
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.types.ColumnType
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Table
import ru.landgrafhomyak.serdha.api.v0.runtime.ParametersSetter
import ru.landgrafhomyak.serdha.api.v0.runtime._ParametersSetter

@Suppress("ClassName")
public interface _CommonCreateQueryScope<QueryUserExtension : Any> {
	public val types: ColumnType.Builder

	public fun <SelectedTableUserExtension : Any> selectTable(t: Table<SelectedTableUserExtension, *>): SelectedTable<SelectedTableUserExtension, QueryUserExtension>

	public interface CanBeSubquery<@Suppress("unused") SelectedQueryUserExtension : Any>

	public interface SubqueryParametersSetter<SubqueryUserExtension : Any, QueryUserExtension : Any> : ParametersSetter<SubqueryUserExtension> {
		public operator fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> set(c: InputParam<RuntimeType, DatabaseType, QueryUserExtension>, value: Expression<RuntimeType, DatabaseType, QueryUserExtension>)
	}

	public fun <SubqueryUserExtension : Any> selectQuery(q: CanBeSubquery<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedTable<SubqueryUserExtension, QueryUserExtension>

	public class SelectedDiff<SubqueryUserExtension : Any, QueryUserExtension : Any>(
		public val inserted: SelectedTable<SubqueryUserExtension, QueryUserExtension>,
		public val updated: SelectedTable<SubqueryUserExtension, QueryUserExtension>
	)

	public fun <SubqueryUserExtension : Any> selectInsert(q: InsertQuery<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedDiff<SubqueryUserExtension, QueryUserExtension>

	@Suppress("FunctionName")
	@LowLevelApi
	public fun <SubqueryUserExtension : Any> _selectCopy(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (_ParametersSetter._Multi<CreateInsertQueryScope.DataParam<SubqueryUserExtension>, Nothing>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension>

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any> selectCopyOne(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (ParametersSetter<CreateInsertQueryScope.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension> =
		this._selectCopy(q, p, r)

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any, T> selectCopyMulti(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		data: Iterable<T>,
		r: (T, ParametersSetter<CreateInsertQueryScope.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension> =
		this._selectCopy(q, p) { rr -> for (e in data) r(e, rr) }

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> param(name: String, type: DatabaseType): InputParam<RuntimeType, DatabaseType, QueryUserExtension>

	public val expressionBuilder: Expression.Builder<QueryUserExtension>

	public interface _ReturningClauseScope<QueryUserExtension : Any> {
		public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> returnExpression(expression: Expression<RuntimeType, DatabaseType, QueryUserExtension>): Column<RuntimeType, DatabaseType, QueryUserExtension>

		public val isDistinct: Boolean

		public fun orderBy(order: SelectQuery.Order, vararg columns: Expression<*, *, QueryUserExtension>)

		public fun groupBy(vararg columns: Expression<*, *, QueryUserExtension>)
	}
}